extends layout

append stylesheets
append scripts
    script var role = !{JSON.stringify(role).replace(/<\//g, "<\\/")}
    script var allTotalRequests = !{JSON.stringify(newRequests).replace(/<\//g, "<\\/")}
    script var allRegions = !{JSON.stringify(allRegions).replace(/<\//g, "<\\/")}
    script var allProvinces = !{JSON.stringify(allProvinces).replace(/<\//g, "<\\/")}
    script var allCities = !{JSON.stringify(allCities).replace(/<\//g, "<\\/")}
    script(src='js/models/Request.js')
    script(src='js/page_scripts/ps_requests.js')

block content
    //- Header
    +header-with-buttons('requests')
    //- Table Content 
    div.section
        +requests-table
                
    +floating-action-btn('requests')
        li
          a.btn-floating.tooltipped.teal.lighten-2.modal-trigger(href='#add-modal' data-bind='click:initializeLogRequestForm' data-position='top' data-tooltip='Log New Request')
            i.material-icons add
        li
          a.btn-floating.tooltipped.teal.lighten-2.sidenav-trigger(data-target='filter-sidenav-slideout' data-position='top' data-tooltip='Toggle Filter')
            i.material-icons filter_list
        li
          a.btn-floating.tooltipped.teal.lighten-2(data-bind='click:deleteSelectedRequests' data-position='top' data-tooltip='Delete Selected Requests')
            i.material-icons delete

    //- Modals
    div#add-modal.modal.modal-fixed-footer
        form#log-request-form
            div.modal-content
                h5 Log New Request
                div.divider
                h6 Institution
                div.row
                    div.input-field.col.s12
                        i.material-icons.prefix local_hospital
                        label(for='beneficiary-name') Institution Name
                        input#beneficiary-name.validate(type='text' aria-required='true' autocomplete='off' maxlength=200 required)
                div.row
                    div.input-field.col.s12.l6 
                        i.material-icons.prefix account_circle
                        label(for='beneficiary-contact-person') Contact Person
                        input#beneficiary-contact-person.validate(type='text' autocomplete='off' required)
                    div.input-field.col.s12.l6
                        i.material-icons.prefix phone
                        label(for='beneficiary-contact-number') Contact Number
                        input#beneficiary-contact-number.validate(type='text' maxlength=50 required)
                h6 Location &nbsp;&nbsp;
                    br
                    small#location-validation-msg.red-text Location is required!
                br
                div.row
                    div.input-field.col.s12.l4.region-select-wrapper
                        select#region-select.validate(name='region-select' 
                            data-bind=`options:regions, 
                                    optionsText:'name', 
                                    optionsValue:'id', 
                                    value:region, 
                                    optionsAfterRender:function(opt, item) {
                                        setTimeout(() => {
                                            $(opt.parentElement).formSelect()
                                        }, 100)
                                    }`
                            )
                        label(for='region-select') Region
                    div.input-field.col.s12.l4.province-select-wrapper(data-bind='visible:provinceEnabled')
                        select#province-select.validate(name='province-select' 
                            data-bind=`value:province,
                                options:filteredProvinces,
                                optionsText:'name',
                                optionsValue:'id',
                                optionsAfterRender:function(opt, item) {
                                    setTimeout(() => {
                                        $(opt.parentElement).formSelect()
                                    }, 50)
                                }`
                            )
                        label(for='province-select') Province
                    div.input-field.col.s12.l4.city-select-wrapper(data-bind='visible:cityEnabled')
                        select#city-select.validate(name='city-select' 
                            data-bind=`value:city,
                                options:filteredCities,
                                optionsText:'name',
                                optionsValue:'id',
                                optionsAfterRender:function(opt, item) {
                                    setTimeout(() => {
                                        $(opt.parentElement).formSelect()
                                    }, 50)
                                }`
                            )
                        label(for='city-select') City / Municipality

            div.modal-footer
                button#log-request-form-submit-btn.btn.waves-effect(name='action' type='submit') SAVE
                a.modal-close.waves-effect.waves-green.btn-flat CLOSE

    div#request-details-modal.modal
            div.modal-content(data-bind='using:selectedRequest') 
                h5 Request Details
                div.divider
                div.row 
                    ul.tabs.teal.lighten-4
                        li.tab.col.s6 
                            a.active.teal.white-text(href='#beneficiary-tab') Institution
                        li.tab.col.s6 
                            a.teal.white-text(href='#request-tab') Request
                div#beneficiary-tab.col.s12
                    //- Institution tab
                    div.row
                        div.input-field.col.s12
                            i.material-icons.prefix local_hospital
                            label Institution Name      
                            input#details-beneficiary-name(type='text' data-bind='value:Name')
                    div.row
                        div.input-field.col.s12.l6 
                            //- i.material-icons.prefix account_circle
                            label(for='details-beneficiary-contact-person') Contact Person
                            input#details-beneficiary-contact-person(type='text' autocomplete='off' data-bind='value:ContactPerson')
                        div.input-field.col.s12.l6
                            //- i.material-icons.prefix phone
                            label(for='details-beneficiary-contact-number') Contact Number
                            input#details-beneficiary-contact-number(type='text' data-length=12 maxlength=50 autocomplete='off' data-bind='value:ContactNumber')
                    div.row
                        div.input-field.col.s12.l4
                            select#details-beneficiary-type(data-bind='value:Type')
                                option(value='' disabled selected) -- Choose -- 
                                option(value='Public') Public
                                option(value='Private') Private
                            label(for='details-beneficiary-type') Type
                        div.input-field.col.s12.l4
                            select#details-beneficiary-classification(data-bind='value:Classification')
                                option(value='' disabled selected) -- Choose -- 
                                option(value='LGU') LGU
                                option(value='RHU') RHU
                                option(value='NGO') NGO
                                option(value='Hospital') Hospital
                                option(value='Funeral Parlor') Funeral Parlor
                                option(value='Health Facility') Health Facility 
                                option(value='Government Agency') Government Agency
                            label(for='details-beneficiary-classification') Classification
                        div.input-field.col.s12.l4
                            input#details-beneficiary-designation(type='text' autocomplete='off' data-bind='value:Designation')
                            label(for='details-beneficiary-designation') Designation
                    div.row
                        div.input-field.col.s12.l4.region-select-wrapper
                            select#details-region-select.validate(name='details-region-select' 
                                data-bind=`options:$parent.regions, 
                                        optionsText:'name', 
                                        optionsValue:'id', 
                                        value:$root.region, 
                                        optionsAfterRender:function(opt, item) {
                                            setTimeout(() => {
                                                $(opt.parentElement).formSelect()
                                            }, 100)
                                        }`
                                )
                            label(for='details-region-select') Region
                        div.input-field.col.s12.l4.province-select-wrapper
                            select#details-province-select.validate(name='details-province-select' 
                                data-bind=`value:$root.province,
                                    options:$root.filteredProvinces,
                                    optionsText:'name',
                                    optionsValue:'id',
                                    optionsAfterRender:function(opt, item) {
                                        setTimeout(() => {
                                            $(opt.parentElement).formSelect()
                                        }, 50)
                                    }`
                                )
                            label(for='details-province-select') Province
                        div.input-field.col.s12.l4.city-select-wrapper
                            select#details-city-select.validate(name='details-city-select' 
                                data-bind=`value:$root.city,
                                    options:$root.filteredCities,
                                    optionsText:'name',
                                    optionsValue:'id',
                                    optionsAfterRender:function(opt, item) {
                                        setTimeout(() => {
                                            $(opt.parentElement).formSelect()
                                        }, 50)
                                    }`
                                )
                            label(for='details-city-select') City / Municipality
                div#request-tab.col.s12
                    //- Request Tab 
                    div.row
                        div.input-field.col.s12.l4 
                            select#details-request-type(data-bind='value:RequestType')
                                option(value='' disabled selected) -- Choose -- 
                                option(value='P') PPE(s)
                                option(value='T') Medical Supplies
                            label(for='details-request-type') Request Type
                        div.input-field.col.s12.l4
                            input#details-request-allocation(type='number' data-bind='value:Allocation' min=0)
                            label(for='details-request-allocation') Allocation
                        div.input-field.col.s12.l4
                            input#details-request-receiver(type='text' autocomplete='off' data-bind='value:Receiver')
                            label(for='details-request-receiver') Receiver
                    div.row
                        div.input-field.col.s12
                            textarea#details-request-requests.materialize-textarea(data-bind='value:Requests')
                            label(for='details-request-requests') Requests
                    div.row
                        div.input-field.col.s12
                            textarea#details-request-remarks.materialize-textarea(data-bind='value:Remarks')
                            label(for='details-request-remarks') Remarks
                        
            div.modal-footer.bottom
                div.validation-loader-container(data-bind='visible:isValidating')
                    div.preloader-wrapper.small.left.active(style='width:24px;height:24px')
                        div.spinner-layer.spinner-green-only
                            div.circle-clipper.left
                                div.circle
                            div.gap-patch
                                div.circle
                            div.circle-clipper.right
                                div.circle
                    span.validation-text.left &nbsp;&nbsp;Validating...
                | &nbsp;&nbsp;
                a.btn.waves-effect.waves-light(data-bind='click:confirmSaveChanges') SAVE
                | &nbsp;&nbsp;
                a.btn.waves-effect.waves-light(data-bind='click:confirmDetailsForm') CONFIRM
                | &nbsp;&nbsp;
                a.modal-close.waves-effect.waves-green.btn-flat(href='') CLOSE
